import { world, EquipmentSlot } from "@minecraft/server"
const equipmentSlots = [EquipmentSlot.Head, EquipmentSlot.Chest, EquipmentSlot.Legs, EquipmentSlot.Feet, EquipmentSlot.Offhand]

world.afterEvents.entityDie.subscribe(e => {
    const entity = e.deadEntity

    if (entity.typeId === 'minecraft:player') {
        let { x, y, z } = entity.location
        x = Math.floor(x) + 0.5; y = Math.floor(y); z = Math.floor(z) + 0.5

        entity.dimension.fillBlocks({ x, y, z }, { x, y, z }, 'effect99:grave')
        const block = entity.dimension.getBlock({ x, y, z })
        const inventory = entity.getComponent("inventory").container
        const graveEntity = entity.dimension.spawnEntity('entity:grave_inventory', { x, y, z })
        const graveInventory = graveEntity.getComponent("inventory").container
        graveEntity.nameTag = `§c${entity.nameTag} \n R.I.P`

        let isEmpty = true

        for (let i = 0; i < 36; i++) {
            const item = inventory.getItem(i)
            graveInventory.setItem(i, item)
            if (item) isEmpty = false
        }
        const equipment = entity.getComponent('equippable')
        let i = 37
        for (const slot of equipmentSlots) {
            const item = equipment.getEquipmentSlot(slot).getItem()
            graveInventory.setItem(i, item)
            equipment.setEquipment(slot, undefined)
            if (item) isEmpty = false
            i++
        }
        inventory.clearAll()
        if (isEmpty) graveEntity.remove()
        const permutation = block.permutation
        block.setPermutation(permutation.withState("block:rotation", Math.floor(Math.random() * 4 + 1)))
    }
})

world.afterEvents.worldInitialize.subscribe(() => {
    world.getDimension('overworld').runCommand('gamerule keepinventory true')
})